#!/usr/bin/env python3
import importlib
import sys
from parse_command import parse_command

class Buffer: # all the information about the current file
	def carat(self):
		return self.index
	def dollar(self):
		return self.length() - 1 + self.index

	# Rather than get the content as it's presented in the buffer object
	# (as one big string), get it as a list.
	def content_list(self):
		return self.split(self.delimiter)

	# Build a string with the same format as the buffer.content and set the
	# buffer.content to that string, from the kind of list output by
	# buffer.content_list().
	# buffer.content_set_list(buffer.content_list()) is an expensive nop.
	def content_set_list(self, content_as_list):
		content = ""
		for line in content_as_list:
			content += line + self.delimiter
		self.content = content
		return None

	# this is really bad because any module can call import_module_ just as
	# easily as any other. so malicious modules that, say, take 'q' and
	# make it upload a file to some external server before exiting would be
	# super easy to make.
	# the solution I see is OS-level permissions but this needs to be
	# talked about like all the time if this tool gets popular
	# [why would it?] lest some fool runs a zelda.sh script that changes
	# ~/src/it/w.py and doesn't realize in time
	def import_module_(self, name):
		try:
			self.modules[name] = importlib.import_module(name)
		except (ModuleNotFoundError, TypeError) as err:
			print(err)
			return False
		else:
			return True

	def length(self):
		return self.content.count(self.delimiter)

	def __init__(self):
		self.content = '' # content of the file
		self.delimiter = '\n' # line delimiter
		self.filename = "" # name of where we'll save the file
		self.index = 0 # indexing of dot
		self.dot = self.index - 1 # invalid position to start
		self.modules = {}
		self.saved = 1 # bool that says whether or not we have saved the file

def main(buffer, command):
	if len(command) == 1:
		command = command + list(vars(buffer))
	for attrib in command[1:]:
		if attrib in list(vars(buffer)):
			print("%s:\t%s" % (attrib, vars(buffer)[attrib]))
		else:
			print("No attribute: %s" % attrib)
	return buffer
